package com.hammingweight.hammockexamples;

import jmunit.framework.cldc10.Test;
import jmunit.framework.cldc10.TestRunner;
import jmunit.framework.cldc10.TestSuite;

import com.hammingweight.hammockexamples.example1.GetNameTest;
import com.hammingweight.hammockexamples.example2.PersonDaoTest;
import com.hammingweight.hammockexamples.example3.StreamCipherTest;
import com.hammingweight.hammockexamples.example4.GetName2Test;
import com.hammingweight.hammockexamples.example4.HttpConnectionFactoryTest;
import com.hammingweight.hammockexamples.example5.ViewBookingsListTest;
import com.hammingweight.hammockexamples.example6.ConcreteSpyTest;

public class AllTests extends TestRunner {

	private Test nestedTest;
	
	public AllTests() {
		super(1000);
		this.nestedTest = new InnerTestSuite();
	}
	
	protected Test getNestedTest() {
		return this.nestedTest;
	}

	public static class InnerTestSuite extends TestSuite {

		public InnerTestSuite() {
			super("AllTests");
			add(new GetNameTest());
			add(new PersonDaoTest());
			add(new StreamCipherTest());
			add(new GetName2Test());
			add(new HttpConnectionFactoryTest());
			add(new ViewBookingsListTest());
			add(new ConcreteSpyTest());
		}
	}
}
