/*
 * ConstructorWrapper.java
 *  
 * Copyright 2007 C.A. Meijer
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.hammingweight.hammockmaker;

import java.lang.reflect.Constructor;

/**
 *
 * @author Carl
 */
public class ConstructorWrapper extends AMethodWrapper {
   
   private String className;
   
   /** Creates a new instance of ConstructorWrapper */
   public ConstructorWrapper(String className, Constructor<?> constructor) {
      super(new Arguments(constructor.getParameterTypes()),
            new Exceptions(constructor.getExceptionTypes()));
      this.className = className;
   }
   
   public String getDeclaration() {
      String s = "public " + className + "(";
      s += this.getArguments().getArgList();
      s += ") ";
      s += this.getExceptions().getThrowsClause();

      return s;
   }
   
   public String getAugmentedDeclaration() {
      String s = "public " + className + "(";
      s += this.getArguments().getArgList();
      if (this.getArguments().getNumberOfArgs() != 0) {
         s += ", ";
      }
      s += "IInvocationHandler handler) ";
      s += this.getExceptions().getThrowsClause();

      return s;
   }
}
