package com.hammingweight.hammock;

import java.util.Stack;
import java.util.Vector;

import junit.framework.TestCase;

public class ClassArgumentMatcherTest extends TestCase {

	private ClassArgumentMatcher argMatcher = new ClassArgumentMatcher();

	public void testArgumentClassesEqual() {
		// Some valid matches.
		assertTrue(this.argMatcher.areArgumentsEqual("", ""));
		assertTrue(this.argMatcher.areArgumentsEqual("1", ""));
		
		// Some invalid matches
		assertFalse(this.argMatcher.areArgumentsEqual(new Integer(1), "1"));
		assertFalse(this.argMatcher.areArgumentsEqual(null, ""));
		assertFalse(this.argMatcher.areArgumentsEqual("", null));
		assertFalse(this.argMatcher.areArgumentsEqual(null, null));
	}

	// We don't check strictly for equality of classes; we check if the actual
	// argument can be cast to the class of the expected argument.
	public void testSubClass() {
		// A Stack is a Vector and an Object
		assertTrue(this.argMatcher.areArgumentsEqual(new Vector(), new Stack()));
		assertTrue(this.argMatcher.areArgumentsEqual(new Object(), new Stack()));

		// A vector isn't a stack.
		assertFalse(this.argMatcher
				.areArgumentsEqual(new Stack(), new Vector()));
		assertFalse(this.argMatcher
				.areArgumentsEqual(new Stack(), new Object()));
	}
}
